Index: EcnlProtoTool/trunk/asp3_dcre/kernel/eventflag.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/eventflag.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/eventflag.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2017 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -216,5 +216,5 @@
 	flgatr = pk_cflg->flgatr;
 
-	CHECK_RSATR(flgatr, TA_TPRI|TA_WMUL|TA_CLR);
+	CHECK_VALIDATR(flgatr, TA_TPRI|TA_WMUL|TA_CLR);
 
 	lock_cpu();
@@ -292,16 +292,18 @@
 set_flg(ID flgid, FLGPTN setptn)
 {
-	FLGCB	*p_flgcb;
-	QUEUE	*p_queue;
-	TCB		*p_tcb;
-	WINFO_FLG *p_winfo_flg;
-	ER		ercd;
+	FLGCB		*p_flgcb;
+	QUEUE		*p_queue;
+	TCB			*p_tcb;
+	WINFO_FLG	*p_winfo_flg;
+	bool_t		lock;
+	ER			ercd;
 
 	LOG_SET_FLG_ENTER(flgid, setptn);
-	CHECK_UNL();
+	lock = sense_lock();
 	CHECK_ID(VALID_FLGID(flgid));
 	p_flgcb = get_flgcb(flgid);
 
-	lock_cpu();
+	if (!lock)
+		lock_cpu();
 	if (p_flgcb->p_flginib->flgatr == TA_NOEXS) {
 		ercd = E_NOEXS;
@@ -328,10 +330,11 @@
 			}
 			else {
-				request_dispatch();
+				request_dispatch_retint();
 			}
 		}
 		ercd = E_OK;
 	}
-	unlock_cpu();
+	if (!lock)
+		unlock_cpu();
 
   error_exit:
@@ -351,12 +354,14 @@
 {
 	FLGCB	*p_flgcb;
+	bool_t lock;
 	ER		ercd;
 
 	LOG_CLR_FLG_ENTER(flgid, clrptn);
-	CHECK_TSKCTX_UNL();
+	lock = sense_lock();
 	CHECK_ID(VALID_FLGID(flgid));
 	p_flgcb = get_flgcb(flgid);
 
-	lock_cpu();
+	if (!lock)
+		lock_cpu();
 	if (p_flgcb->p_flginib->flgatr == TA_NOEXS) {
 		ercd = E_NOEXS;
@@ -366,5 +371,6 @@
 		ercd = E_OK;
 	}
-	unlock_cpu();
+	if (!lock)
+		unlock_cpu();
 
   error_exit:
@@ -383,7 +389,7 @@
 wai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
 {
-	FLGCB	*p_flgcb;
-	WINFO_FLG winfo_flg;
-	ER		ercd;
+	FLGCB		*p_flgcb;
+	WINFO_FLG	winfo_flg;
+	ER			ercd;
 
 	LOG_WAI_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn);
@@ -411,6 +417,6 @@
 		winfo_flg.waiptn = waiptn;
 		winfo_flg.wfmode = wfmode;
-		p_runtsk->tstat = TS_WAITING_FLG;
-		wobj_make_wait((WOBJCB *) p_flgcb, (WINFO_WOBJ *) &winfo_flg);
+		wobj_make_wait((WOBJCB *) p_flgcb, TS_WAITING_FLG,
+											(WINFO_WOBJ *) &winfo_flg);
 		dispatch();
 		ercd = winfo_flg.winfo.wercd;
@@ -477,8 +483,8 @@
 twai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout)
 {
-	FLGCB	*p_flgcb;
-	WINFO_FLG winfo_flg;
-	TMEVTB	tmevtb;
-	ER		ercd;
+	FLGCB		*p_flgcb;
+	WINFO_FLG	winfo_flg;
+	TMEVTB		tmevtb;
+	ER			ercd;
 
 	LOG_TWAI_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn, tmout);
@@ -510,7 +516,6 @@
 		winfo_flg.waiptn = waiptn;
 		winfo_flg.wfmode = wfmode;
-		p_runtsk->tstat = TS_WAITING_FLG;
-		wobj_make_wait_tmout((WOBJCB *) p_flgcb, (WINFO_WOBJ *) &winfo_flg,
-														&tmevtb, tmout);
+		wobj_make_wait_tmout((WOBJCB *) p_flgcb, TS_WAITING_FLG,
+								(WINFO_WOBJ *) &winfo_flg, &tmevtb, tmout);
 		dispatch();
 		ercd = winfo_flg.winfo.wercd;
@@ -575,11 +580,13 @@
 	FLGCB	*p_flgcb;
 	ER		ercd;
-    
+	bool_t lock;
+
 	LOG_REF_FLG_ENTER(flgid, pk_rflg);
-	CHECK_TSKCTX_UNL();
+	lock = sense_lock();
 	CHECK_ID(VALID_FLGID(flgid));
 	p_flgcb = get_flgcb(flgid);
 
-	lock_cpu();
+	if (!lock)
+		lock_cpu();
 	if (p_flgcb->p_flginib->flgatr == TA_NOEXS) {
 		ercd = E_NOEXS;
@@ -590,5 +597,6 @@
 		ercd = E_OK;
 	}
-	unlock_cpu();
+	if (!lock)
+		unlock_cpu();
 
   error_exit:
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/eventflag.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/eventflag.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/eventflag.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -51,5 +51,5 @@
 
   def prepare(key, params)
-    # flgatrが無効の場合（E_RSATR）［NGKI1562］
+    # flgatrが無効の場合（E_RSATR）［NGKI1562］［NGKI1550］
     #（TA_TPRI，TA_WMUL，TA_CLR以外のビットがセットされている場合）
     if (params[:flgatr] & ~($TA_TPRI|$TA_WMUL|$TA_CLR)) != 0
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/exception.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/exception.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/exception.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -51,16 +51,28 @@
 
 #
+#  DEF_EXCで使用できるCPU例外ハンドラ番号のデフォルト定義
+#
+if !defined?($EXCNO_DEFEXC_VALID)
+  $EXCNO_DEFEXC_VALID = $EXCNO_VALID
+end
+
+#
 #  CPU例外ハンドラに関するエラーチェック
 #
-$cfgData[:DEF_EXC].each do |key, params|
-  # excnoがCPU例外ハンドラ番号として正しくない場合（E_PAR）［NGKI3134］
-  if $EXCNO_VALID.index(params[:excno]).nil?
+$cfgData[:DEF_EXC].each do |_, params|
+  # excnoが有効範囲外の場合（E_PAR）［NGKI3134］
+  if !$EXCNO_DEFEXC_VALID.include?(params[:excno])
     error_illegal("E_PAR", params, :excno)
   end
 
-  # excatrが無効の場合（E_RSATR）［NGKI3131］
+  # excatrが無効の場合（E_RSATR）［NGKI3131］［NGKI5178］［NGKI3123］
   #（TARGET_EXCATR以外のビットがセットされている場合）
   if (params[:excatr] & ~($TARGET_EXCATR)) != 0
     error_illegal_sym("E_RSATR", params, :excatr, :excno)
+  end
+
+  # ターゲット依存のエラーチェック
+  if defined? TargetCheckDefExc()
+    TargetCheckDefExc(params)
   end
 end
@@ -82,5 +94,5 @@
     #  CPU例外ハンドラのエントリ
     #
-    $cfgData[:DEF_EXC].each do |key, params|
+    $cfgData[:DEF_EXC].each do |_, params|
       $kernelCfgC.add("EXCHDR_ENTRY(#{params[:excno]}, " \
 						"#{params[:excno].val}, #{params[:exchdr]})")
@@ -92,5 +104,5 @@
     #
     $kernelCfgC.add("const EXCINIB _kernel_excinib_table[TNUM_DEF_EXCNO] = {")
-    $cfgData[:DEF_EXC].each_with_index do |(key, params), index|
+    $cfgData[:DEF_EXC].each_with_index do |(_, params), index|
       $kernelCfgC.add(",") if index > 0
       $kernelCfgC.append("\t{ (#{params[:excno]}), (#{params[:excatr]}), " \
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/genoffset.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/genoffset.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/genoffset.trb	(revision 429)
@@ -1,9 +1,8 @@
 # -*- coding: utf-8 -*-
+#
+#   TOPPERS Software
+#       Toyohashi Open Platform for Embedded Real-Time Systems
 # 
-#   TOPPERS/ASP Kernel
-#       Toyohashi Open Platform for Embedded Real-Time Systems/
-#       Advanced Standard Profile Kernel
-# 
-#   Copyright (C) 2011-2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2011-2018 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 #  
@@ -37,5 +36,5 @@
 #   の責任を負わない．
 # 
-#   $Id$
+#   $Id: genoffset.trb 936 2018-04-07 09:46:42Z ertl-hiro $
 # 
 
@@ -44,25 +43,18 @@
 #
 
-# 
+#
 #  タイムスタンプファイルの指定
-# 
+#
 $timeStampFileName = "offset.timestamp"
 
-# 
+#
 #  offset.hの先頭部分の生成
-# 
+#
 $offsetH = GenFile.new("offset.h")
 $offsetH.add2("/* offset.h */")
 
-# 
-#  #defineディレクティブの生成
-# 
-def GenerateDefine(symbol, value)
-  $offsetH.add("#define #{symbol}\t#{value}")
-end
-
-# 
+#
 #  ビットのサーチ
-# 
+#
 def SearchBit(val)
   (0..7).each do |valBit|
@@ -74,8 +66,8 @@
 end
 
-# 
-#  ビットフィールドのオフセットとビット位置の定義の生成
-# 
-def GenerateDefineBit(label, structSize, outputSize)
+#
+#  ビットフィールドのオフセットとビット位置の算出
+#
+def BitOffsetPosition(label, structSize, outputSize)
   top = SYMBOL(label)
   if top.nil?
@@ -96,52 +88,44 @@
       error_exit("bit not found in `#{label}'")
     else
-      valBit = SearchBit(val)
+      position = SearchBit(val)
       case outputSize
-      when "W"
-        if $SIL_ENDIAN_BIG
-          valBit = valBit + 24 - ((offset & 0x03) << 3)
+      when 4, "W"
+        if $endianLittle
+          position = position + ((offset & 0x03) << 3)
         else
-          valBit = valBit + ((offset & 0x03) << 3)
+          position = position + 24 - ((offset & 0x03) << 3)
         end
         offset &= ~0x03
-      when "H"
-        if $SIL_ENDIAN_BIG
-          valBit = valBit + 8 - ((offset & 0x01) << 3)
+      when 2, "H"
+        if $endianLittle
+          position = position + ((offset & 0x01) << 3)
         else
-          valBit = valBit + ((offset & 0x01) << 3)
+          position = position + 8 - ((offset & 0x01) << 3)
         end
         offset &= ~0x01
       end
     end
-
-    $offsetH.add("#define #{label}\t#{offset}")
-    $offsetH.add("#define #{label}_bit\t#{valBit}")
-    $offsetH.add("#define #{label}_mask\t#{sprintf("0x%x", 1 << valBit)}")
+    return offset, position
   end
 end
 
-# 
-#  バイト配置のチェック
-# 
-def magicCheck(size, check)
-  label = "MAGIC_#{size}"
-  top = SYMBOL(label)
-  if top.nil?
-    error_exit("label `#{label}' not found")
-  else
-    1.upto(size).each do |offset|
-      if $SIL_ENDIAN_BIG
-        val = PEEK(top + offset - 1, 1)
-      else
-        val = PEEK(top + size - offset, 1)
-      end
-      if val != check.at(offset - 1)
-        error_exit("value check of `#{label}' failed")
-      end
-    end
+# 以下の定義は，過去のバージョンとの互換性のために残している．
+
+#
+#  #defineディレクティブの生成
+#
+def GenerateDefine(symbol, value)
+  $offsetH.add("#define #{symbol}\t#{value}")
+end
+
+#
+#  ビットフィールドのオフセットとビット位置の定義の生成
+#
+def GenerateDefineBit(label, structSize, outputSize)
+  offset, position = BitOffsetPosition(label, structSize, outputSize)
+  if !offset.nil?
+    GenerateDefine(label, offset)
+    GenerateDefine("#{label}_bit", position)
+    GenerateDefine("#{label}_mask", sprintf("0x%x", 1 << position))
   end
 end
-
-magicCheck(1, [ 0x12 ])
-magicCheck(2, [ 0x12, 0x34 ])
-magicCheck(4, [ 0x12, 0x34, 0x56, 0x78 ])
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/interrupt.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/interrupt.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/interrupt.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -93,4 +93,28 @@
 #endif /* LOG_ENA_INT_LEAVE */
 
+#ifndef LOG_CLR_INT_ENTER
+#define LOG_CLR_INT_ENTER(intno)
+#endif /* LOG_CLR_INT_ENTER */
+
+#ifndef LOG_CLR_INT_LEAVE
+#define LOG_CLR_INT_LEAVE(ercd)
+#endif /* LOG_CLR_INT_LEAVE */
+
+#ifndef LOG_RAS_INT_ENTER
+#define LOG_RAS_INT_ENTER(intno)
+#endif /* LOG_RAS_INT_ENTER */
+
+#ifndef LOG_RAS_INT_LEAVE
+#define LOG_RAS_INT_LEAVE(ercd)
+#endif /* LOG_RAS_INT_LEAVE */
+
+#ifndef LOG_PRB_INT_ENTER
+#define LOG_PRB_INT_ENTER(intno)
+#endif /* LOG_PRB_INT_ENTER */
+
+#ifndef LOG_PRB_INT_LEAVE
+#define LOG_PRB_INT_LEAVE(ercd)
+#endif /* LOG_PRB_INT_LEAVE */
+
 #ifndef LOG_CHG_IPM_ENTER
 #define LOG_CHG_IPM_ENTER(intpri)
@@ -108,4 +132,35 @@
 #define LOG_GET_IPM_LEAVE(ercd, p_intpri)
 #endif /* LOG_GET_IPM_LEAVE */
+
+/*
+ *  割込み番号の範囲の判定
+ */
+#ifndef VALID_INTNO_DISINT
+#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
+#endif /* VALID_INTNO_DISINT */
+
+#ifndef VALID_INTNO_CLRINT
+#define VALID_INTNO_CLRINT(intno)	VALID_INTNO(intno)
+#endif /* VALID_INTNO_CLRINT */
+
+#ifndef VALID_INTNO_RASINT
+#define VALID_INTNO_RASINT(intno)	VALID_INTNO(intno)
+#endif /* VALID_INTNO_RASINT */
+
+#ifndef VALID_INTNO_PRBINT
+#define VALID_INTNO_PRBINT(intno)	VALID_INTNO(intno)
+#endif /* VALID_INTNO_PRBINT */
+
+#ifndef VALID_INTNO_CREISR
+#define VALID_INTNO_CREISR(intno)	VALID_INTNO(intno)
+#endif /* VALID_INTNO_CREISR */
+
+/*
+ *  割込み優先度の範囲の判定
+ */
+#ifndef VALID_INTPRI_CHGIPM
+#define VALID_INTPRI_CHGIPM(intpri)	\
+					(TMIN_INTPRI <= (intpri) && (intpri) <= TIPM_ENAALL)
+#endif /* VALID_INTPRI_CHGIPM */
 
 /*
@@ -266,5 +321,5 @@
 	isrpri = pk_cisr->isrpri;
 
-	CHECK_RSATR(isratr, TARGET_ISRATR);
+	CHECK_VALIDATR(isratr, TARGET_ISRATR);
 	CHECK_PAR(VALID_INTNO_CREISR(intno));
 	CHECK_PAR(FUNC_ALIGN(isr));
@@ -384,5 +439,6 @@
 		lock_cpu();
 	}
-	if (disable_int(intno)) {					/*［NGKI3086］*/
+	if (check_intno_cfg(intno)) {
+		disable_int(intno);						/*［NGKI3086］*/
 		ercd = E_OK;
 	}
@@ -421,5 +477,6 @@
 		lock_cpu();
 	}
-	if (enable_int(intno)) {					/*［NGKI3099］*/
+	if (check_intno_cfg(intno)) {
+		enable_int(intno);						/*［NGKI3099］*/
 		ercd = E_OK;
 	}
@@ -438,4 +495,117 @@
 #endif /* TOPPERS_SUPPORT_ENA_INT */
 #endif /* TOPPERS_ena_int */
+
+/*
+ *  割込み要求のクリア［NGKI3920］
+ */
+#ifdef TOPPERS_clr_int
+#ifdef TOPPERS_SUPPORT_CLR_INT					/*［NGKI3927］*/
+
+ER
+clr_int(INTNO intno)
+{
+	bool_t	locked;
+	ER		ercd;
+
+	LOG_CLR_INT_ENTER(intno);
+	CHECK_PAR(VALID_INTNO_CLRINT(intno));		/*［NGKI3921］［NGKI3930］*/
+
+	locked = sense_lock();
+	if (!locked) {
+		lock_cpu();
+	}
+	if (check_intno_cfg(intno) && check_intno_clear(intno)) {
+		clear_int(intno);						/*［NGKI3924］*/
+		ercd = E_OK;
+	}
+	else {
+		ercd = E_OBJ;							/*［NGKI3923］［NGKI3929］*/
+	}
+	if (!locked) {
+		unlock_cpu();
+	}
+
+  error_exit:
+	LOG_CLR_INT_LEAVE(ercd);
+	return(ercd);
+}
+
+#endif /* TOPPERS_SUPPORT_CLR_INT */
+#endif /* TOPPERS_clr_int */
+
+/*
+ *  割込みの要求［NGKI3932］
+ */
+#ifdef TOPPERS_ras_int
+#ifdef TOPPERS_SUPPORT_RAS_INT					/*［NGKI3939］*/
+
+ER
+ras_int(INTNO intno)
+{
+	bool_t	locked;
+	ER		ercd;
+
+	LOG_RAS_INT_ENTER(intno);
+	CHECK_PAR(VALID_INTNO_RASINT(intno));		/*［NGKI3933］［NGKI3942］*/
+
+	locked = sense_lock();
+	if (!locked) {
+		lock_cpu();
+	}
+	if (check_intno_cfg(intno) && check_intno_raise(intno)) {
+		raise_int(intno);						/*［NGKI3936］*/
+		ercd = E_OK;
+	}
+	else {
+		ercd = E_OBJ;							/*［NGKI3935］［NGKI3941］*/
+	}
+	if (!locked) {
+		unlock_cpu();
+	}
+
+  error_exit:
+	LOG_RAS_INT_LEAVE(ercd);
+	return(ercd);
+}
+
+#endif /* TOPPERS_SUPPORT_RAS_INT */
+#endif /* TOPPERS_ras_int */
+
+/*
+ *  割込み要求のチェック［NGKI3944］
+ */
+#ifdef TOPPERS_prb_int
+#ifdef TOPPERS_SUPPORT_PRB_INT					/*［NGKI3951］*/
+
+ER_BOOL
+prb_int(INTNO intno)
+{
+	bool_t	locked;
+	ER_BOOL	ercd;
+
+	LOG_PRB_INT_ENTER(intno);
+	CHECK_PAR(VALID_INTNO_PRBINT(intno));		/*［NGKI3945］［NGKI3952］*/
+
+	locked = sense_lock();
+	if (!locked) {
+		lock_cpu();
+	}
+	if (check_intno_cfg(intno)) {
+		ercd = (ER_BOOL) probe_int(intno);		/*［NGKI3948］*/
+	}
+	else {
+		ercd = E_OBJ;							/*［NGKI3947］*/
+	}
+	if (!locked) {
+		unlock_cpu();
+	}
+
+  error_exit:
+	LOG_PRB_INT_LEAVE(ercd);
+	return(ercd);
+}
+
+#endif /* TOPPERS_SUPPORT_PRB_INT */
+#endif /* TOPPERS_prb_int */
 
 /*
@@ -456,6 +626,5 @@
 	t_set_ipm(intpri);							/*［NGKI3111］*/
 	if (intpri == TIPM_ENAALL && enadsp) {
-		dspflg = true;
-		p_schedtsk = search_schedtsk();
+		set_dspflg();
 		if (p_runtsk->raster && p_runtsk->enater) {
 			task_terminate(p_runtsk);
Index: EcnlProtoTool/trunk/asp3_dcre/kernel/interrupt.trb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/kernel/interrupt.trb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/kernel/interrupt.trb	(revision 429)
@@ -6,5 +6,5 @@
 # 
 #   Copyright (C) 2015 by FUJI SOFT INCORPORATED, JAPAN
-#   Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+#   Copyright (C) 2015-2019 by Embedded and Real-Time Systems Laboratory
 #               Graduate School of Information Science, Nagoya Univ., JAPAN
 # 
@@ -38,5 +38,5 @@
 #   の責任を負わない．
 # 
-#   $Id$
+#   $Id: interrupt.trb 1167 2019-02-03 17:06:17Z ertl-hiro $
 # 
 
@@ -54,8 +54,8 @@
 #  フォルト定義
 #
-if $INTNO_CREISR_VALID.nil?
+if !defined?($INTNO_CREISR_VALID)
   $INTNO_CREISR_VALID = $INTNO_VALID
 end
-if $INHNO_CREISR_VALID.nil?
+if !defined?($INHNO_CREISR_VALID)
   $INHNO_CREISR_VALID = $INHNO_VALID
 end
@@ -64,5 +64,5 @@
 #  CFG_INTで使用できる割込み優先度のデフォルト定義
 # 
-if $INTPRI_CFGINT_VALID.nil?
+if !defined?($INTPRI_CFGINT_VALID)
   $INTPRI_CFGINT_VALID = $TMIN_INTPRI.upto($TMAX_INTPRI).to_a
 end
@@ -87,11 +87,11 @@
 #  割込み要求ラインに関するエラーチェック
 #
-$cfgData[:CFG_INT].each do |key, params|
-  #	intnoが割込み番号として正しくない場合（E_PAR）［NGKI2972］
-  if $INTNO_VALID.index(params[:intno]).nil?
+$cfgData[:CFG_INT].each do |_, params|
+  # intnoが有効範囲外の場合（E_PAR）［NGKI2972］
+  if !$INTNO_VALID.include?(params[:intno])
     error_illegal("E_PAR", params, :intno)
   end
 
-  #	intatrが無効の場合（E_RSATR）［NGKI2969］
+  # intatrが無効の場合（E_RSATR）［NGKI2969］［NGKI2944］［NGKI2945］
   #（TA_ENAINT，TA_EDGE，TARGET_INTATR以外のビットがセットされている場合）
   if (params[:intatr] & ~($TA_ENAINT|$TA_EDGE|$TARGET_INTATR)) != 0
@@ -99,30 +99,33 @@
   end
 
-  #	intpriがCFG_INTに対する割込み優先度として正しくない場合（E_PAR）
-  #	［NGKI2973］
-  if $INTPRI_CFGINT_VALID.index(params[:intpri]).nil?
-    error_illegal_sym("E_OBJ", params, :intpri, :intno)
-  end
-
-  # カーネル管理外に固定されているintnoに対して，intpriにTMIN_INTPRIよ
-  #	りも小さい値が指定されなかった場合（E_OBJ）［NGKI2983］
-  if !$INTNO_FIX_NONKERNEL.nil?
-    if !$INTNO_FIX_NONKERNEL.index(params[:intno]).nil?
-      if params[:intpri] >= $TMIN_INTPRI
-        error_ercd("E_OBJ", params, "%%intno must have higher priority " \
+  # intpriがCFG_INTに対する割込み優先度として正しくない場合（E_PAR）
+  # ［NGKI2973］
+  if !$INTPRI_CFGINT_VALID.include?(params[:intpri])
+    error_illegal_sym("E_PAR", params, :intpri, :intno)
+  end
+
+  # カーネル管理外に固定されているintnoに対して，intpriにTMIN_INTPRI以
+  # 上の値が指定された場合（E_OBJ）［NGKI2983］
+  if defined?($INTNO_FIX_NONKERNEL) \
+				&& $INTNO_FIX_NONKERNEL.include?(params[:intno])
+    if params[:intpri] >= $TMIN_INTPRI
+      error_ercd("E_OBJ", params, "%%intno must have higher priority " \
 											"than TMIN_INTPRI in %apiname")
-      end
-    end
-  end
-
-  #	カーネル管理に固定されているintnoに対して，intpriにTMIN_INTPRIより
-  #	も小さい値が指定された場合（E_OBJ）［NGKI2984］
-  if !$INTNO_FIX_KERNEL.nil?
-    if !$INTNO_FIX_KERNEL.index(params[:intno]).nil?
-      if params[:intpri] < $TMIN_INTPRI
-        error_ercd("E_OBJ", params, "%%intno must have lower or equal " \
+    end
+  end
+
+  # カーネル管理に固定されているintnoに対して，intpriにTMIN_INTPRIより
+  # も小さい値が指定された場合（E_OBJ）［NGKI2984］
+  if defined?($INTNO_FIX_KERNEL) \
+				&& $INTNO_FIX_KERNEL.include?(params[:intno])
+    if params[:intpri] < $TMIN_INTPRI
+      error_ercd("E_OBJ", params, "%%intno must have lower or equal " \
 									"priority to TMIN_INTPRI in %apiname")
-      end
-    end
+    end
+  end
+
+  # ターゲット依存のエラーチェック［NGKI2985］
+  if defined? TargetCheckCfgInt()
+    TargetCheckCfgInt(params)
   end
 end
@@ -131,11 +134,11 @@
 #  割込みハンドラに関するエラーチェック
 #
-$cfgData[:DEF_INH].each do |key, params|
-  # inhnoが割込みハンドラ番号として正しくない場合（E_PAR）［NGKI3055］
-  if $INHNO_VALID.index(params[:inhno]).nil?
+$cfgData[:DEF_INH].each do |_, params|
+  # inhnoが有効範囲外の場合（E_PAR）［NGKI3055］
+  if !$INHNO_VALID.include?(params[:inhno])
     error_illegal("E_PAR", params, :inhno)
   end
 
-  # inhatrが無効の場合（E_RSATR）［NGKI3052］
+  # inhatrが無効の場合（E_RSATR）［NGKI3052］［NGKI2957］［NGKI2959］
   #（TARGET_INHATR以外のビットがセットされている場合）
   if (params[:inhatr] & ~($TARGET_INHATR)) != 0
@@ -143,27 +146,26 @@
   end
 
-  #	カーネル管理外に固定されているinhnoに対して，inhatrにTA_NONKERNELが
-  #	指定されていない場合（E_RSATR）［NGKI3067］
-  if !$INHNO_FIX_NONKERNEL.nil?
-    if !$INHNO_FIX_NONKERNEL.index(params[:inhno]).nil?
-      if (params[:inhatr] & $TA_NONKERNEL) == 0
-        error_ercd("E_RSATR", params, "%%inhno must be " \
+  # カーネル管理外に固定されているinhnoに対して，inhatrにTA_NONKERNELが
+  # 指定されていない場合（E_RSATR）［NGKI3067］
+  if defined?($INHNO_FIX_NONKERNEL) \
+				&& $INHNO_FIX_NONKERNEL.include?(params[:inhno])
+    if (params[:inhatr] & $TA_NONKERNEL) == 0
+      error_ercd("E_RSATR", params, "%%inhno must be " \
 								"non-kernel interrupt in %apiname")
-      end
-    end
-  end
-
-  #	カーネル管理に固定されているinhnoに対して，inhatrにTA_NONKERNELが指
-  #	定されている場合（E_RSATR）［NGKI3068］
-  if !$INHNO_FIX_KERNEL.nil?
-    if !$INHNO_FIX_KERNEL.index(params[:inhno]).nil?
-      if (params[:inhatr] & $TA_NONKERNEL) != 0
-        error_ercd("E_RSATR", params, "%%inhno must not be " \
+    end
+  end
+
+  # カーネル管理に固定されているinhnoに対して，inhatrにTA_NONKERNELが指
+  # 定されている場合（E_RSATR）［NGKI3068］
+  if defined?($INHNO_FIX_KERNEL) \
+				&& $INHNO_FIX_KERNEL.include?(params[:inhno])
+    if (params[:inhatr] & $TA_NONKERNEL) != 0
+      error_ercd("E_RSATR", params, "%%inhno must not be " \
 								"non-kernel interrupt in %apiname")
-      end
-    end
-  end
-
-  if $toIntnoVal.has_key?(params[:inhno].val)
+    end
+  end
+
+  if $INHNO_CREISR_VALID.include?(params[:inhno])
+    # 割込みハンドラ番号に対応する割込み番号がある場合
     intnoVal = $toIntnoVal[params[:inhno].val]
 
@@ -174,4 +176,5 @@
     else
       intnoParams = $cfgData[:CFG_INT][intnoVal]
+
       if (params[:inhatr] & $TA_NONKERNEL) == 0
         # inhatrにTA_NONKERNELが指定されておらず，inhnoに対応するintno
@@ -193,4 +196,9 @@
     end
   end
+
+  # ターゲット依存のエラーチェック［NGKI3078］
+  if defined? TargetCheckDefInh()
+    TargetCheckDefInh(params)
+  end
 end
 
@@ -198,6 +206,6 @@
 #  割込みサービスルーチン（ISR）に関するエラーチェック
 #
-$cfgData[:CRE_ISR].sort.each do |key, params|
-  #	isratrが無効の場合（E_RSATR）［NGKI2998］
+$cfgData[:CRE_ISR].sort.each do |_, params|
+  # isratrが無効の場合（E_RSATR）［NGKI2998］［NGKI2952］［NGKI5176］
   #（TARGET_ISRATR以外のビットがセットされている場合）
   if (params[:isratr] & ~($TARGET_ISRATR)) != 0
@@ -205,52 +213,42 @@
   end
 
-  #	intnoがCRE_ISRに対する割込み番号として正しくない場合（E_PAR）
-  #	［NGKI3003］
-  if $INTNO_CREISR_VALID.index(params[:intno]).nil?
+  # intnoが有効範囲外の場合（E_PAR）［NGKI3003］
+  if !$INTNO_CREISR_VALID.include?(params[:intno])
     error_illegal("E_PAR", params, "intno")
   end
 
-  #	(TMIN_ISRPRI <= isrpri && isrpri <= TMAX_ISRPRI)でない場合（E_PAR）
-  #	［NGKI3005］
+  # isrpriが有効範囲外の場合（E_PAR）［NGKI3005］
+  #（TMIN_ISRPRI <= isrpri && isrpri <= TMAX_ISRPRIでない場合）
   if !($TMIN_ISRPRI <= params[:isrpri] && params[:isrpri] <= $TMAX_ISRPRI)
     error_illegal("E_PAR", params, "isrpri")
   end
-end
-
-$INTNO_CREISR_VALID.each do |intnoVal|
-  # 割込み番号intnoに対して登録されたISRのリストの作成
-  isrParamsList = []
-  $cfgData[:CRE_ISR].sort.each do |key, params|
-    if params[:intno] == intnoVal
-      isrParamsList.push(params)
-    end
-  end
-
-  #	割込み番号intnoに対して登録されたISRが存在する場合
-  if isrParamsList.size > 0
-    inhnoVal = $toInhnoVal[intnoVal]
-
-    # intnoに対応するinhnoに対してDEF_INHがある場合（E_OBJ）［NGKI3013］
-    if $cfgData[:DEF_INH].has_key?(inhnoVal)
-      inhnoParams = $cfgData[:DEF_INH][inhnoVal]
-      error_ercd("E_OBJ", isrParamsList[0], "%%intno in %apiname " \
-					"is duplicated with inhno #{inhnoParams[:inhno]}")
-    end
-
-    # intnoに対するCFG_INTがない場合（E_OBJ）［NGKI3012］
-    if !$cfgData[:CFG_INT].has_key?(intnoVal)
-      error_ercd("E_OBJ", isrParamsList[0], "%%intno in %apiname " \
+
+  # intnoに対応するinhnoに対してDEF_INHがある場合（E_OBJ）［NGKI3013］
+  inhnoVal = $toInhnoVal[params[:intno].val]
+  if $cfgData[:DEF_INH].has_key?(inhnoVal)
+    error_ercd("E_OBJ", params, "%%intno in %apiname is duplicated " \
+					"with inhno #{$cfgData[:DEF_INH][inhnoVal][:inhno]}")
+  end
+
+  # intnoに対するCFG_INTがない場合（E_OBJ）［NGKI3012］
+  if !$cfgData[:CFG_INT].has_key?(params[:intno])
+    error_ercd("E_OBJ", params, "%%intno in %apiname " \
 									"is not configured with CFG_INT")
-    else
-      intnoParams = $cfgData[:CFG_INT][intnoVal]
-
-      #	intnoに対してCFG_INTで設定された割込み優先度がTMIN_INTPRIよりも
-      #	小さい場合（E_OBJ）［NGKI3014］
-      if intnoParams[:intpri] < $TMIN_INTPRI
-        error_ercd("E_OBJ", isrParamsList[0],
-						"intpri `#{intnoParams[:intpri]}' configured for " \
-						"%%intno with CFG_INT in higher than TMIN_INTPRI")
-      end
-    end
+  else
+    intnoParams = $cfgData[:CFG_INT][params[:intno]]
+
+    # intnoでカーネル管理外の割込みを指定した場合（E_OBJ）［NGKI3014］
+    #（intnoに対してCFG_INTで設定された割込み優先度がTMIN_INTPRIよりも小
+    #  さい場合）
+    if intnoParams[:intpri] < $TMIN_INTPRI
+      error_ercd("E_OBJ", params,
+					"intpri `#{intnoParams[:intpri]}' configured for " \
+					"%%intno with CFG_INT in higher than TMIN_INTPRI")
+    end
+  end
+
+  # ターゲット依存のエラーチェック
+  if defined? TargetCheckCreIsr()
+    TargetCheckCreIsr(params)
   end
 end
@@ -298,5 +296,5 @@
   inhnoVal = $toInhnoVal[intnoVal]
 
-  # 次のDEF_INHに相当するデータを生成
+  # 次の静的APIに相当するデータを生成
   # DEF_INH(inhno, { TA_NULL, _kernel_inthdr_<intno> } );
   $cfgData[:DEF_INH][inhnoVal] = {
@@ -306,5 +304,5 @@
   }
 
-  # 割込みサービスルーチン用の割込みハンドラ
+  # 割込みサービスルーチンを呼び出す割込みハンドラの生成［NGKI2941］
   $kernelCfgC.add("void")
   $kernelCfgC.add("_kernel_inthdr_#{intnoVal}(void)")
@@ -335,12 +333,17 @@
 
 # 割込みサービスルーチン生成順序テーブルの生成
-$kernelCfgC.add("const ID _kernel_isrorder_table[TNUM_SISRID] = { ")
-$kernelCfgC.append("\t")
-$cfgData[:CRE_ISR].each_with_index do |(key, params), index|
-  $kernelCfgC.append(", ") if index > 0
-  $kernelCfgC.append("#{params[:isrid]}")
-end
-$kernelCfgC.add
-$kernelCfgC.add2("};")
+if $cfgData[:CRE_ISR].size != 0
+  $kernelCfgC.add("const ID _kernel_isrorder_table[TNUM_SISRID] = { ")
+  $kernelCfgC.append("\t")
+  $cfgData[:CRE_ISR].each_with_index do |(_, params), index|
+    $kernelCfgC.append(", ") if index > 0
+    $kernelCfgC.append("#{params[:isrid]}")
+  end
+  $kernelCfgC.add
+  $kernelCfgC.add2("};")
+else
+  $kernelCfgC.add2("TOPPERS_EMPTY_LABEL(const ID, " \
+										"_kernel_isrorder_table);")
+end
 
 #
@@ -360,5 +363,5 @@
     #  割込みハンドラのエントリ
     #
-    $cfgData[:DEF_INH].each do |key, params|
+    $cfgData[:DEF_INH].each do |_, params|
       if (params[:inhatr] & $TA_NONKERNEL) == 0
         $kernelCfgC.add("INTHDR_ENTRY(#{params[:inhno]}, " \
@@ -372,5 +375,5 @@
     #
     $kernelCfgC.add("const INHINIB _kernel_inhinib_table[TNUM_DEF_INHNO] = {")
-    $cfgData[:DEF_INH].each_with_index do |(key, params), index|
+    $cfgData[:DEF_INH].each_with_index do |(_, params), index|
       $kernelCfgC.add(",") if index > 0
       if (params[:inhatr] & $TA_NONKERNEL) == 0
@@ -407,5 +410,5 @@
   if $cfgData[:CFG_INT].size != 0
     $kernelCfgC.add("const INTINIB _kernel_intinib_table[TNUM_CFG_INTNO] = {")
-    $cfgData[:CFG_INT].each_with_index do |(key, params), index|
+    $cfgData[:CFG_INT].each_with_index do |(_, params), index|
       $kernelCfgC.add(",") if index > 0
       $kernelCfgC.append("\t{ (#{params[:intno]}), (#{params[:intatr]}), " \
